/* Name: ds18b20.c
Пример чтения датчика DS18B20 .Пример подключения ОДНОГО датчика на ОДИН вывод м/к !! размер кода чуть больше 300 байт.
Взято с http://homes-smart.ru/index.php/oborudovanie/datchiki/ds18b20
Проверено на м/к AVR
 */
#define timer 10 // время в секундах.

#define DS_BIT         4 // pin 3
#define DS_DDR DDRB
#define DS_PORT PORTB

#include <avr/io.h>
#include <avr/wdt.h>
#include <util/delay.h>     /* for _delay_us() */


//------------------------------------------------
//------------------Подпрограммы------------------
//------------------------------------------------
// OneWire библиотеки

void OneWireReset() 
{

     DS_PORT &= ~_BV(DS_BIT);
     DS_DDR |= _BV(DS_BIT);
     _delay_us(500);
     DS_DDR &= ~_BV(DS_BIT);
     _delay_us(500);
}

void OneWireOutByte(uint8_t d) 
{
   uint8_t n;

   for(n=8; n!=0; n--)
   {
      if ((d & 0x01) == 1) 
      {

	 DS_PORT &= ~_BV(DS_BIT);
	 DS_DDR |= _BV(DS_BIT);
         _delay_us(5);
	 DS_DDR &= ~_BV(DS_BIT);
         _delay_us(60);
      }
      else
      {
	 DS_PORT &= ~_BV(DS_BIT);
	 DS_DDR |= _BV(DS_BIT);
         _delay_us(60);
	 DS_DDR &= ~_BV(DS_BIT);
      }
      d=d>>1; 
   }
}


uint8_t OneWireInByte() 
{
    uint8_t d, n,b;

    for (n=0; n<8; n++)
    {
	DS_PORT &= ~_BV(DS_BIT);
	DS_DDR |= _BV(DS_BIT);
        _delay_us(5);
	DS_DDR &= ~_BV(DS_BIT);
        _delay_us(5);
	b = ((PINB & _BV(DS_BIT)) != 0);
        _delay_us(50);
        d = (d >> 1) | (b<<7);
    }
    return(d);
}



//------------------------------------------------
//-----------------Main программа-----------------
//------------------------------------------------
int __attribute__((noreturn)) main(void)
{
  

    //начальная установка для ds18b20
    DS_DDR |= _BV(DS_BIT);
    DS_PORT &= ~_BV(DS_BIT);
    DS_DDR &= ~_BV(DS_BIT);


    for(;;){                /* Основной цикл программы */
	

	_delay_ms(timer*1000); 

   // ds начало          

  int tempds,HighByte, TReading;
  uint8_t  LowByte, SignBit;
  
     OneWireReset();
     OneWireOutByte(0xcc);
     OneWireOutByte(0x44);
     //strong
       DS_PORT |= _BV(DS_BIT);
       DS_DDR |= _BV(DS_BIT);
       //delay(1000);
       DS_DDR &= ~_BV(DS_BIT);
       DS_PORT &= ~_BV(DS_BIT);
     
     
     OneWireReset();
     OneWireOutByte(0xcc);
     OneWireOutByte(0xbe);

     LowByte = OneWireInByte();
     HighByte = OneWireInByte();
     
     TReading = (HighByte << 8) + LowByte;
     SignBit = TReading & 0x8000;  
     if (SignBit)
     {
         TReading = (TReading ^ 0xffff) + 1; 
     }
     tempds = (6 * TReading) + TReading / 4;  

//ds ---

// тут можно считать данные переменной 	tempds*100 

    }
    
}



